<?php
require_once 'Mail.php';
require_once 'Mail/mime.php';

define('ALERT_ADDRESSES', 'koyama@example.com');
define('NOTIFY_FROM', 'notify@example.com');
define('SMTP_HOST', 'mail.example.com');

class HNotifier {

    function alert($obj) {
        $serialized = serialize($obj);

        $recpts = ALERT_ADDRESSES;
        $headers = array('From' => NOTIFY_FROM,
                         'To' => $recpts,
                         'Subject' => 'PHP Runtime Alert Report');
        $mime = new Mail_mime;
        $mime->addAttachment($serialized,
                             'text/x.php-serialized',
                             'php_stackdump.dmp',
                             false, 'base64');
        $body = $mime->get();
        $mheaders = $mime->headers($headers);

        return HNotifier::_send($recpts, $mheaders, $body);
    }

    function _send(&$recpts, &$headers, $body) {
        mb_convert_variables('JIS', 'EUC-JP', $body);

        $m =& Mail::factory('smtp', array('host' => SMTP_HOST));
        return $m->send($recpts, $headers, $body);
    }
}
?>